<launch>
  <param name="use_sim_time" value="true"/>
    
  <arg name="path" default="/media/isr/Data/logs/realsense-d435i_velodyne-vlp16/20200316"/>

  <arg name="input" default="two_vlp16_2020-03-16-18-52-52.bag"/>
  <arg name="vlp16_front_height" default="0.81"/>
  <arg name="vlp16_tilted_height" default="0.905"/>
  <node name="vlp16_front_broadcaster" pkg="tf" type="static_transform_publisher" args="0 0 0.905 0 0 0 base_link velodyne_front 100" />
  <node name="vlp16_tilted_broadcaster" pkg="tf" type="static_transform_publisher" args="0.095 0 0.81 0 0.262 0 base_link velodyne_tilted 100" />

  <!-- Run a passthrough filter to clean ground and walls -->
  <node pkg="nodelet" type="nodelet" name="pcl_manager" args="manager" output="screen" />
  <node pkg="nodelet" type="nodelet" name="vlp16_front_passthrough_x" args="load pcl/PassThrough pcl_manager" output="screen">
    <remap from="~input" to="velodyne_front/velodyne_points"/>
    <remap from="~output" to="velodyne_front/velodyne_points/passthrough"/>
    <rosparam>
      filter_field_name: x
      filter_limit_min: -20
      filter_limit_max: 20
      filter_limit_negative: False
    </rosparam>
  </node>
  <node pkg="nodelet" type="nodelet" name="vlp16_front_passthrough_y" args="load pcl/PassThrough pcl_manager" output="screen">
    <remap from="~input" to="velodyne_front/velodyne_points/passthrough"/>
    <remap from="~output" to="velodyne_front/velodyne_points/filtered"/>
    <rosparam>
      filter_field_name: y
      filter_limit_min: -20
      filter_limit_max: 20
      filter_limit_negative: False
    </rosparam>
  </node>
  <node pkg="nodelet" type="nodelet" name="vlp16_tilted_passthrough_x" args="load pcl/PassThrough pcl_manager" output="screen">
    <remap from="~input" to="velodyne_tilted/velodyne_points"/>
    <remap from="~output" to="velodyne_tilted/velodyne_points/passthrough"/>
    <rosparam>
      filter_field_name: x
      filter_limit_min: -20
      filter_limit_max: 20
      filter_limit_negative: False
    </rosparam>
  </node>
  <node pkg="nodelet" type="nodelet" name="vlp16_tilted_passthrough_y" args="load pcl/PassThrough pcl_manager" output="screen">
    <remap from="~input" to="velodyne_tilted/velodyne_points/passthrough"/>
    <remap from="~output" to="velodyne_tilted/velodyne_points/filtered"/>
    <rosparam>
      filter_field_name: y
      filter_limit_min: -20
      filter_limit_max: 20
      filter_limit_negative: False
    </rosparam>
  </node>

  <!-- GroundPlaneFit -->
  <node name="vlp16_front_groundplanefit" pkg="points_preprocessor_usi" type="groundplanfit" output="screen">
    <param name="point_topic" value="/velodyne_front/velodyne_points/filtered"/>  <!-- default: /velodyne_points -->
    <param name="no_ground_point_topic" value="/velodyne_front/velodyne_points/filtered/no_ground"/>  <!-- default: /points_no_ground -->
    <param name="ground_point_topic" value="/velodyne_front/velodyne_points/filtered/ground"/>  <!-- default: /points_ground -->
    <remap from="all_points" to="/velodyne_front/velodyne_points/filtered/all_points"/>

    <!-- in Paper: Nsegs=3/Niter=3/Nlpr=20/THseeds=0.4m/THdist=0.2m -->
    <param name="sensor_model" value="16"/>  <!-- default: 32 -->
    <param name="sensor_height" value="$(arg vlp16_front_height)"/>  <!-- default: 2.5 -->
    <param name="num_seg" value="5"/>  <!-- default: 1 -->
    <param name="num_iter" value="10"/>  <!-- default: 3 -->
    <param name="num_lpr" value="128"/>  <!-- default: 20 -->
    <param name="th_seeds" value="0.4"/>  <!-- default: 1.2 -->
    <param name="th_dist" value="0.2"/>  <!-- default: 0.3 -->
  </node>
  <node name="vlp16_tilted_groundplanefit" pkg="points_preprocessor_usi" type="groundplanfit" output="screen">
    <param name="point_topic" value="/velodyne_tilted/velodyne_points/filtered"/>  <!-- default: /velodyne_points -->
    <param name="no_ground_point_topic" value="/velodyne_tilted/velodyne_points/filtered/no_ground"/>  <!-- default: /points_no_ground -->
    <param name="ground_point_topic" value="/velodyne_tilted/velodyne_points/filtered/ground"/>  <!-- default: /points_ground -->
    <remap from="all_points" to="/velodyne_tilted/velodyne_points/filtered/all_points"/>

    <!-- in Paper: Nsegs=3/Niter=3/Nlpr=20/THseeds=0.4m/THdist=0.2m -->
    <param name="sensor_model" value="16"/>  <!-- default: 32 -->
    <param name="sensor_height" value="$(arg vlp16_tilted_height)"/>  <!-- default: 2.5 -->
    <param name="num_seg" value="5"/>  <!-- default: 1 -->
    <param name="num_iter" value="10"/>  <!-- default: 3 -->
    <param name="num_lpr" value="128"/>  <!-- default: 20 -->
    <param name="th_seeds" value="0.4"/>  <!-- default: 1.2 -->
    <param name="th_dist" value="0.2"/>  <!-- default: 0.3 -->
  </node>

  <!-- rosbag play -->
  <node name="rqt_bag" pkg="rqt_bag" type="rqt_bag" args="--clock $(arg path)/$(arg input)">
    <remap from="/tf" to="/tf_old"/>
  </node>

  <!-- rviz -->
  <node name="rviz" pkg="rviz" type="rviz" args="-d $(find realsense-d435i_velodyne-vlp16)/rviz/two_vlp16_groundplanefit.rviz" />
</launch>
